// Helper to transform an expression into an expression statement.
"use strict";

exports.__esModule = true;
exports["default"] = toStatement;

function toStatement(t, expression) {
  if (t.isConditionalExpression(expression)) {
    return t.toIfStatement(expression);
  }
  if (t.isFunctionExpression(expression)) {
    return t.toStatement(expression);
  }
  if (!t.isStatement(expression)) {
    return t.expressionStatement(expression);
  }
  return expression;
}

module.exports = exports["default"];