"use strict";

exports.__esModule = true;
exports["default"] = attrsToAttrCalls;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _runtimeAttr = require("./runtime/attr");

var _runtimeAttr2 = _interopRequireDefault(_runtimeAttr);

var _runtimeForOwn = require("./runtime/for-own");

var _runtimeForOwn2 = _interopRequireDefault(_runtimeForOwn);

var _astToFunctionCall = require("./ast/to-function-call");

// Transforms an attribute array into sequential attr calls.

var _astToFunctionCall2 = _interopRequireDefault(_astToFunctionCall);

function attrsToAttrCalls(t, file, attrs) {
  var forOwn = undefined,
      forOwnAttr = undefined;

  return attrs.map(function (attr) {
    if (t.isJSXSpreadAttribute(attr)) {
      if (!forOwn) {
        forOwn = _runtimeForOwn2["default"](t, file);
        forOwnAttr = _runtimeAttr2["default"](t, file);
      }
      return _astToFunctionCall2["default"](t, forOwn, [attr.argument, forOwnAttr]);
    }

    return _astToFunctionCall2["default"](t, "attr", attr);
  });
}

module.exports = exports["default"];