"use strict";

exports.__esModule = true;
exports["default"] = cleanText;
var nonWhitespace = /\S/;
var newlines = /\r\n?|\n/;

// Trims the whitespace off the line.
function lineFilter(lines, line, i, _ref) {
  var length = _ref.length;

  if (i > 0) {
    line = line.trimLeft();
  }
  if (i + 1 < length) {
    line = line.trimRight();
  }
  if (line) {
    lines.push(line);
  }

  return lines;
}

// Cleans the whitespace from a text node.

function cleanText(value) {
  if (!nonWhitespace.test(value)) {
    return "";
  }

  var lines = value.split(newlines);
  lines = lines.reduce(lineFilter, []);

  return lines.join(" ");
}

module.exports = exports["default"];