"use strict";

exports.__esModule = true;
exports["default"] = injectForOwn;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _inject = require("../inject");

var _inject2 = _interopRequireDefault(_inject);

var _hasOwn = require("./has-own");

var _hasOwn2 = _interopRequireDefault(_hasOwn);

var _astToFunctionCallStatement = require("../ast/to-function-call-statement");

// Loops over all own properties, calling
// the specified iterator function with
// value and prop name.
// Depends on the _hasOwn helper.

var _astToFunctionCallStatement2 = _interopRequireDefault(_astToFunctionCallStatement);

function forOwnAST(t, ref, deps) {
  var hasOwn = deps.hasOwn;
  var object = t.identifier("object");
  var iterator = t.identifier("iterator");
  var prop = t.identifier("prop");

  /**
   * function _forOwn(object, iterator) {
   *   for (var prop in object) {
   *     if (hasOwn.call(object, prop)) {
   *       iterator(object[prop], prop);
   *     }
   *   }
   * }
   */
  return t.functionDeclaration(ref, [object, iterator], t.blockStatement([t.forInStatement(t.variableDeclaration("var", [prop]), object, t.ifStatement(t.callExpression(t.memberExpression(hasOwn, t.identifier("call")), [object, prop]), _astToFunctionCallStatement2["default"](t, iterator, [t.memberExpression(object, prop, true), prop])))]));
}

function injectForOwn(t, file) {
  var forcedRef = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  return _inject2["default"](t, file, forcedRef, "forOwn", forOwnAST, {
    hasOwn: _hasOwn2["default"]
  });
}

module.exports = exports["default"];