"use strict";

exports.__esModule = true;
exports["default"] = injectJSXWrapper;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _inject = require("../inject");

var _inject2 = _interopRequireDefault(_inject);

var _astToFunctionCallStatement = require("../ast/to-function-call-statement");

// Loops over all own properties, calling
// the specified iterator function with
// value and prop name.
// Depends on the _hasOwn helper.

var _astToFunctionCallStatement2 = _interopRequireDefault(_astToFunctionCallStatement);

function jsxWrapperAST(t, ref) {
  var func = t.identifier("func");
  var jsxProp = t.memberExpression(func, t.identifier("__jsxDOMWrapper"));

  /**
   * function _jsxWrapper(func) {
   *   func.__jsxDOMWrapper = true;
   *   return func;
   * }
   */
  return t.functionDeclaration(ref, [func], t.blockStatement([t.expressionStatement(t.AssignmentExpression("=", jsxProp, t.literal(true))), t.returnStatement(func)]));
}

function injectJSXWrapper(t, file) {
  var forcedRef = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  return _inject2["default"](t, file, forcedRef, "jsxWrapper", jsxWrapperAST);
}

module.exports = exports["default"];